#include <16F877.h>
#device adc=10
#FUSES NOWDT                  //No Watch Dog Timer
#FUSES HS                     //High speed Osc (> 4mhz)

#use delay(clock=4000000)

INT PlusFlag , overflow, FlagRelaks = 0, First = 1, CounterFirst = 0, value, x = 100, cutCounter = 0, a = 0, b = 0, relaks = 0;




#int_TIMER0
void  TIMER0_isr(void) 
{
 overflow = 1;
}



/* ""*/
void cRelaks (void)
{
  if(FlagRelaks == 1)
    {
      relaks++ ;
      if(relaks >= 10) { relaks = 0; FlagRelaks =0;}
    }
}


/*   ""  ,   */
void keystrokeCounter(void)
{
  if(First == 1)                              //       ... 
    {
     CounterFirst++ ;                         //    + 1
     if( CounterFirst >= 90 )                 //   90  ...
       {
        First = 0 ;                           //    = 0
        CounterFirst = 0 ;                    //    
       }
    }
 else                                         // ...
    
    #asm                                      //     
    #endasm                                   //   else   if  else if
    
    if(cutCounter >= x)                       //       ...
      {
       
       cutCounter++ ;                         //   + 1
       
       switch (PlusFlag)                      //  ""
       {
         case 1: value++;                     // "" + 1
       
          break;
         
         case 2: value--;                     // "" - 1
       }
       
       x-- ;                                  //   1
       
       if (x <= 10)                           //    10 ...
         
         x = 10;                              //  = 10
      }
    else {a = 1;   First = 1 ;}               //    "  " ;    = 1
}



 /*  */
void Button(void)
{
 if(FlagRelaks == 1) { cRelaks(); }
   
   else   
       #asm                                      //     
       #endasm                                   //   else   if  else if
       
       if(input(Pin_E0)) { PlusFlag = 1; }          //   ""  
          else if(input(Pin_E1)) { PlusFlag = 0; }  //    ""  
             else a = 0; break;                     //   "  " ;  
     
     
           if( a == 1 )                          //      ?
         
             keystrokeCounter();                 //    ""  ,   
         
           else                                  // ...
           
             cutCounter = 0 ;                    //   
             
             x = 100 ;                           //  = 100
            
             switch (PlusFlag)                   //    ?
             {
            
               case 1: value++ ;                 // " + 1"
             
                 break;
             
               case 0: value-- ;                 // " - 1"
                 
             }
       
            FlagRelaks = 1 ;                    //   
            
            a = 1 ;                             //   "  "
            
            First = 1 ;                         //   " "
   }                                             // 




void main()
{

   
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_64);
   setup_timer_2(T2_DIV_BY_16, 255, 1);
   setup_ccp1(CCP_PWM);
   set_tris_e (0xff); // in
   enable_interrupts(int_timer0);
   enable_interrupts(global);
         
      
    WHILE (1)
    {
                   
       Button();                          //   
              
       if(value<10){value=10;}
       
       if(value>245){value = 245;}
       
       set_pwm1_duty(value);
       
    }
}
    
    
    
 






















